#include <stdio.h>
#include <stdlib.h>
#include <ncurses.h>
#include <signal.h>
#include <strings.h>
#include "init.h"
#include "globals.h"
#include "nInvaders.h"

void game_over(int a) 
{
	finish(0);	
	
}

int hit_test(shotx,shoty,alienx,alieny)
{
	int getroffen=0;
	int shipx,shipy=0;
	if (shotx>=alienx && shotx<=alienx+30 && shoty>=alieny && shoty<=alieny+8) {
		shipx=(shotx-alienx)/3;
		shipy=(shoty-alieny)/2;
		if (enemy[shipy][shipx]!=0) {
			enemy[shipy][shipx]=0;	
			getroffen=1;
		//	srandom(shipy*20+shipx+(int)random());
		}
	}
	return getroffen;
}

int bunker_test(shotx,shoty)
{
	int adjx,adjy;
	if (shotx>=BUNKERX && shotx<=BUNKERX+BUNKERWIDTH && shoty>=BUNKERY && shoty<=BUNKERY+BUNKERHEIGHT) {
		// the shot is in the range - do a detailed bunker collision test
		adjy=shoty-BUNKERY;
		adjx=shotx-BUNKERX;
		if(bunker[adjy][adjx]==1)
			{
			bunker[adjy][adjx]=0;
			return 1;
			}
		}
	return 0;
}

int main(int argc,char** argv)
{
	int i;
	int ch;
	int x=0,y=0;
	int movement=1;
	int pos=0;
	int shoot=0;
	int shotx=0;
	int shoty=0;

	int move_counter=0;
	int shot_counter=0;
	int alienshot_counter=0;
	int weite=0;
	int shootme_counter=0;
	WINDOW *battlefield;
	skill_level=1;
	if (argc==3) {
		if (strcmp(argv[1],"-l")==0) {
			if (argv[2][0]>='0' && argv[2][0]<='9') {skill_level=argv[2][0]-48;} else {argc=2;}
		}
	}
	if (argc==2) {
		if (strcmp(argv[1],"-gpl")==0) {
			gpl();
		}
	}
	if (argc==2 || (argc==3 && strcmp(argv[1],"-l")!=0)) {
		fprintf(stderr,"*** nInvaders %i.%i.%i\n",MAJOR,MINOR,RELEASE);
		fprintf(stderr,"*** (C)opyleft 2k2 by Dettus\n");
		fprintf(stderr,"*** dettus@matrixx-bielefeld.de\n");
		fprintf(stderr,"\n\nUsage: nInvaders [-l skill] [-gpl]\n");
		fprintf(stderr,"   where -l 0=NIGHTMARE\n");
		fprintf(stderr,"         -l 1=okay\n");
		fprintf(stderr,"         -l 9=May I play daddy?!\n");
		fprintf(stderr,"\n         -gpl shows you the license file\n");
		version();
		exit(1);	
	}

	init();
	weite=shipnum/10+skill_level;
	battlefield=newwin(SCREENHEIGHT,SCREENWIDTH,0,0);

	mvwin(battlefield,0,0);	
	attrset(COLOR_PAIR(3));
	timeout(0);
	wclear(battlefield);
	copywin(bunkers,battlefield,0,0,BUNKERY,BUNKERX,BUNKERY+BUNKERHEIGHT-1,BUNKERX+BUNKERWIDTH-1,0);
	copywin(player,battlefield,0,0,SCREENHEIGHT-1,pos,SCREENHEIGHT-1,pos+4,0);

	for (;;) {
		if (move_counter==0) 
		{
			render();
			copywin(leer,battlefield,0,0,y,x,y+bottom,x+right+3,0);
			x=x+movement;
			if (x==75-right || x==0+left) {
				y++;
				if (y==SCREENHEIGHT-1-bottom) {game_over(1);}
				movement=movement*(-1);
			}
			copywin(aliens,battlefield,0,0,y,x,y+bottom,x+right+3,0);

		}
		if (shoot==1 && shot_counter==0) 
		{
			copywin(leer,battlefield,0,0,shoty,shotx,shoty,shotx,0);
			shoty--;
			if (shoty<=0) {shoot=0;} else {
				copywin(shot,battlefield,0,0,shoty,shotx,shoty,shotx,0);
			}
			if (hit_test(shotx,shoty,x,y)==1) {
				copywin(leer,battlefield,0,0,y,x,y+bottom,x+right+3,0);
				shoot=0;render();
				if (shipnum==0) {
					game_over(1);
				}
				weite=shipnum/10+skill_level;
				copywin(leer,battlefield,0,0,shoty,shotx,shoty,shotx,0);
				copywin(aliens,battlefield,0,0,y,x,y+bottom,x+right+3,0);
			}
			if (bunker_test(shotx,shoty)==1) { //test if our shot hit the bunker
				copywin(leer,battlefield,0,0,shoty,shotx,shoty,shotx,0);
				shoty=0;
				shoot=0;
			}
		}
		if (alienshot_counter==0) {
			for (i=0;i<50;i++) {
				if (alienshotx[i]!=0) {
					copywin(leer,battlefield,0,0,alienshoty[i],alienshotx[i],alienshoty[i],alienshotx[i],0);
					if (bunker_test(alienshotx[i],alienshoty[i])==1) { //test if alien shot hit the bunker
						copywin(leer,battlefield,0,0,alienshoty[i],alienshotx[i],alienshoty[i],alienshotx[i],0);
						alienshotx[i]=0;
			}
					alienshoty[i]++;
					if (alienshoty[i]==SCREENHEIGHT) {
						if (alienshotx[i]>=pos && alienshotx[i]<=pos+4) {game_over(1);}
						alienshotx[i]=0;
					}
				} else {
					if (shootme_counter++>(skill_level*8+10)*(shipnum+5)) {
						shootme_counter=0;
						ch=random()%11;
						while (lowest_ship[ch]==-1) {
							ch=random()%11;	
						}
						alienshoty[i]=y+lowest_ship[ch];
						alienshotx[i]=x+ch*3;
					}

				}
			}
					
			for (i=0;i<50;i++) {
				if (alienshotx[i]!=0) {
					copywin(alienshot,battlefield,0,0,alienshoty[i],alienshotx[i],alienshoty[i],alienshotx[i],0);
				}
			}
		}
		if (alienshot_counter++>=5) {alienshot_counter=0;}
		if (shot_counter++>=1) {shot_counter=0;}
		if (move_counter++>=weite) {move_counter=0;}
		wrefresh(battlefield);	
	//	refresh();
			
		usleep(1);
		ch=getch();
		if ((ch=='l' || ch==KEY_RIGHT) && pos<SCREENWIDTH-5) {
			copywin(leer,battlefield,0,0,SCREENHEIGHT-1,pos,SCREENHEIGHT-1,pos+4,0);
			pos=pos+1;
			copywin(player,battlefield,0,0,SCREENHEIGHT-1,pos,SCREENHEIGHT-1,pos+4,0);
		}
		if ((ch=='h' || ch==KEY_LEFT)  && pos>0)  {
			copywin(leer,battlefield,0,0,SCREENHEIGHT-1,pos,SCREENHEIGHT-1,pos+4,0);
			pos=pos-1;
			copywin(player,battlefield,0,0,SCREENHEIGHT-1,pos,SCREENHEIGHT-1,pos+4,0);
			mvwin(player,SCREENHEIGHT-1,pos);
		}
		if ((ch=='q' || ch==27)) {finish(0);}
		if ((ch=='k' || ch==' ') && shoot==0) {shoot=1;shotx=pos+2;shoty=22;} 

	}

	return 0;	
	
	
}

static void finish(int sig)
{
        endwin();
fprintf(stderr,"
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


");
	if (shipnum==0) {
		fprintf(stderr,"U rule!\n");
	} else {
		fprintf(stderr,"U suck!\n");
	}
	version();
        exit(0);
}

